#!/usr/bin/python3
import RPi.GPIO as GPIO
import time

########################################
# Program to move the motors.          #
# file: GearMotorControl.py            #
# Author: Th. Kaffka, Cologne, Germany #
# Date: 23/02/2021                     #
########################################

PMWA = 40
AIN2 = 38
AIN1 = 36

PMWB = 37
BIN1 = 35
BIN2 = 33

GPIO.setmode(GPIO.BOARD)
GPIO.setup(PMWA, GPIO.OUT)
GPIO.setup(AIN2, GPIO.OUT)
GPIO.setup(AIN1, GPIO.OUT)
GPIO.setup(PMWB, GPIO.OUT)
GPIO.setup(BIN1, GPIO.OUT)
GPIO.setup(BIN2, GPIO.OUT)

motor_a = GPIO.PWM(PMWA, 100)
motor_a.start(50)
motor_b = GPIO.PWM(PMWB, 100)
motor_b.start(50)

# move motor a
motor_a.ChangeDutyCycle(25)
GPIO.output(AIN1, GPIO.HIGH)
time.sleep(1.0)
GPIO.output(AIN1, GPIO.LOW)
time.sleep(1.0)
GPIO.output(AIN2, GPIO.HIGH)
time.sleep(1.0)
GPIO.output(AIN2, GPIO.LOW)

# move motor b
motor_b.ChangeDutyCycle(25)
GPIO.output(BIN1, GPIO.HIGH)
time.sleep(1.0)
GPIO.output(BIN1, GPIO.LOW)
time.sleep(1.0)
GPIO.output(BIN2, GPIO.HIGH)
time.sleep(1.0)
GPIO.output(BIN2, GPIO.LOW)

GPIO.cleanup()

