#!/usr/bin/python3
##################
# Licht erkennen #
# 3.10.2020      #
##################

import RPi.GPIO as GPIO
import time

LEDPIN = 40
ADCNUM = 0
CLOCKPIN = 35
MOSIPIN = 37
MISOPIN = 36
CSPIN = 38

GPIO.setmode(GPIO.BOARD)
GPIO.setup(LEDPIN, GPIO.OUT, initial=GPIO.LOW)
GPIO.setup(MOSIPIN, GPIO.OUT)
GPIO.setup(MISOPIN, GPIO.IN)
GPIO.setup(CLOCKPIN, GPIO.OUT)
GPIO.setup(CSPIN, GPIO.OUT)

led_red = GPIO.PWM(LEDPIN, 100)
led_red.start(50)

def readadc():
    if ((ADCNUM > 7) or (ADCNUM < 0)):
        return -1
    GPIO.output(CSPIN, True)
 
    GPIO.output(CLOCKPIN, False)  # start clock low
    GPIO.output(CSPIN, False)     # bring CS low
 
    commandout = ADCNUM
    commandout |= 0x18  # start bit + single-ended bit
    commandout <<= 3    # we only need to send 5 bits here
    for i in range(5):
        if (commandout & 0x80):
            GPIO.output(MOSIPIN, True)
        else:
            GPIO.output(MOSIPIN, False)
        commandout <<= 1
        GPIO.output(CLOCKPIN, True)
        GPIO.output(CLOCKPIN, False)
 
    adcout = 0
    # read in one empty bit, one null bit and 10 ADC bits
    for i in range(12):
        GPIO.output(CLOCKPIN, True)
        GPIO.output(CLOCKPIN, False)
        adcout <<= 1
        if (GPIO.input(MISOPIN)):
            adcout |= 0x1
 
    GPIO.output(CSPIN, True)
        
    adcout >>= 1       # first bit is 'null' so drop it
    return adcout

try:
    while True:
        value = readadc()
        print (value)
        value -= 700
        if value < 0:
            value = 0
        ledValue = value * 0.3096
        if ledValue > 100.0:
            ledValue = 100.0
        led_red.ChangeDutyCycle(int(ledValue))    
        time.sleep(0.5)

except KeyboardInterrupt:
    pass
finally:
    GPIO.cleanup() 
