#!/usr/bin/python3
import sys
sys.path.append("/home/pi/Ae/Python/Robots/Interface")
import RPi.GPIO as GPIO
import time
from GearMotor import GearMotor
from Vehicle import Vehicle
from Led import Led
from TouchSensor import TouchSensor
from PiezoSpeaker import PiezoSpeaker

########################################
# program: Motor10                     #
# file: Motor10.py                     #
# Author: Th. Kaffka, Cologne, Germany #
# Date: 12/03/2021                     #
########################################

PMWA = 40 
AIN2 = 38
AIN1 = 36
ENCA = 32

PMWB = 37 
BIN1 = 35
BIN2 = 33
ENCB = 31

button = TouchSensor(11)
led = Led(13) 
speaker = PiezoSpeaker(15)

motor_a = GearMotor(PMWA, AIN2, AIN1, ENCA)
motor_b = GearMotor(PMWB, BIN1, BIN2, ENCB)
vehicle = Vehicle(3.2, 19.5, motor_a, motor_b)

speaker.beepMessageReady()

start = True
led_on = False

try:

   while(True):
      if (start and button.isTouch()):
         start = False
         led.ledOff()
         speaker.beepMessageOk()
         time.sleep(3)
         vehicle.setSpeed(25)
         continue
      elif(start):
         led_on = not led_on
         if (led_on):
            led.ledOn()
         else:
            led.ledOff()
         time.sleep(0.5)
         continue

#      vehicle.forward(100)
      time.sleep(0.3)
      vehicle.rotate(45)
#      time.sleep(0.3)

      speaker.beepMessageEnd()
      break

except KeyboardInterrupt:
   pass
finally:
   GPIO.cleanup()
