#!/usr/bin/python3
import RPi.GPIO as GPIO
import time

####################################################
# Program to move the motors with encoder control. #
# file: MotorEncoder.py                            #
# Author: Th. Kaffka, Cologne, Germany             #
# Date: 23/02/2021                                 #
####################################################

PMWA = 40
AIN2 = 38
AIN1 = 36
ENCA = 32

PMWB = 37
BIN1 = 35
BIN2 = 33
ENCB = 31

GPIO.setmode(GPIO.BOARD)
GPIO.setup(PMWA, GPIO.OUT)
GPIO.setup(AIN2, GPIO.OUT)
GPIO.setup(AIN1, GPIO.OUT)
GPIO.setup(ENCA, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.add_event_detect(ENCA, GPIO.BOTH)

GPIO.setup(PMWB, GPIO.OUT)
GPIO.setup(BIN1, GPIO.OUT)
GPIO.setup(BIN2, GPIO.OUT)
GPIO.setup(ENCB, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.add_event_detect(ENCB, GPIO.BOTH)

motor_a = GPIO.PWM(PMWA, 100)
motor_a.start(50)
motor_b = GPIO.PWM(PMWB, 100)
motor_b.start(50)

# move motor a
motor_a.ChangeDutyCycle(25)
GPIO.output(AIN1, GPIO.HIGH)
motor_b.ChangeDutyCycle(10)
GPIO.output(BIN1, GPIO.HIGH)

count_a = 0
count_b = 0

try:

   while(True):
      if (GPIO.event_detected(ENCA)):
         count_a += 1
      if (GPIO.event_detected(ENCB)):
         count_b += 1
      print (str(count_a) + " " + str(count_b))

except KeyboardInterrupt:
   pass
finally:
   GPIO.cleanup()


