#!C:\Users\Thomas\AppData\Local\Programs\Python\Python35-32\python
########################################
# class PhotoTransistor                #
# file: PhotoTransistor.py             #
# Author: Th. Kaffka, Cologne, Germany #
# Date: 15/03/2021                     #
# Credits: readadc written by:         #
#          Limor "Ladyada" Fried for   #
#          Adafruit Industries         #
########################################

import RPi.GPIO as GPIO

class PhotoTransistor:

   def __init__(self, adcnum, clockpin, mosipin, misopin, cspin):
      self.adcnum = adcnum
      self.clockpin = clockpin
      self.mosipin = mosipin
      self.misopin = misopin
      self.cspin = cspin
      GPIO.setmode(GPIO.BOARD)
      GPIO.setup(mosipin, GPIO.OUT)
      GPIO.setup(misopin, GPIO.IN)
      GPIO.setup(clockpin, GPIO.OUT)
      GPIO.setup(cspin, GPIO.OUT)

   def __del__(self):
      pass 

   def readadc(self, adcnum, clockpin, mosipin, misopin, cspin):
      if ((adcnum > 7) or (adcnum < 0)):
         return -1
      GPIO.output(cspin, True)
 
      GPIO.output(clockpin, False)  # start clock low
      GPIO.output(cspin, False)     # bring CS low
 
      commandout = adcnum
      commandout |= 0x18  # start bit + single-ended bit
      commandout <<= 3    # we only need to send 5 bits here
      for i in range(5):
         if (commandout & 0x80):
            GPIO.output(mosipin, True)
         else:
            GPIO.output(mosipin, False)
         commandout <<= 1
         GPIO.output(clockpin, True)
         GPIO.output(clockpin, False)
 
      adcout = 0
      # read in one empty bit, one null bit and 10 ADC bits
      for i in range(12):
         GPIO.output(clockpin, True)
         GPIO.output(clockpin, False)
         adcout <<= 1
         if (GPIO.input(misopin)):
            adcout |= 0x1
 
      GPIO.output(cspin, True)
        
      adcout >>= 1       # first bit is 'null' so drop it
      return adcout
      
   def readValue(self):
      value = self.readadc(self.adcnum, self.clockpin, self.mosipin, self.misopin, self.cspin)
      return value
