########################################
# morse a text                         #
# file: MorseKey.py                    #
# Author: Th. Kaffka, Cologne, Germany #
# Date: 09/01/2021                     #
########################################
import sys
sys.path.append("/home/pi/Ae/Python/Robots/Interface")
import RPi.GPIO as GPIO
import time
from Led import Led
from PiezoSpeaker import *

led = Led(13)
speaker = PiezoSpeaker(15)

morse_alphabet = [".-", "-...", "-.-.", "-..", ".", "..-.", "--.", "....", \
                  "..", ".---", "-.-", ".-..", "--", "-.", "---", ".--.", \
                  "--.-", ".-.", "...", "-", "..-", "...-", ".--", "-..-", \
                  "-.--", "--.."]

def morseText(text):
   for c in text:
      morse = ''
      char_no = ord(c) - 97

      # get the character code.
      if (c == ' '): morse = 'x' 
      elif (char_no < 0 or char_no > 25):
         print()
         print ("Der Buchstabe", c, "ist nicht definiert!")
         continue
      else:
         morse = morse_alphabet[char_no]

      # morse the character.
      do_morse = list (morse)
      for x in do_morse:
         if (x == '.'):
            led.ledOn()
            speaker.sound(TONE_C5, 0.1)
            led.ledOff()
            print(".", end="")
            time.sleep(0.1)
         if (x == '-'):
            led.ledOn()
            speaker.sound(TONE_C5, 0.3)
            led.ledOff()
            print("-", end="")
            time.sleep(0.1)
         if (x == 'x'):
            time.sleep(0.5)
            print()
            
      if (x != 'x'):
         print(" ", end="")
      time.sleep(0.7)

print("Start")

try:

   while(True):
      print()
      get_text = input("Please enter a text: ").lower()
      time.sleep(1.0)
      morseText(get_text)

except:
   KeyboardInterrupt
finally:
   GPIO.cleanup()

print()
print("End")
