#!/usr/bin/python
##########################################
# prorgam: compass calibration           #
# file: CompassCalibration.py            #
# Author: Th. Kaffka, Cologne, Germany   #
# Date: 12.11.2020                       #
##########################################
import sys
sys.path.append("/home/pi/Ae/Roboter/Interface")
sys.path.append("/home/pi/Ae/Roboter/lib")
import brickpi3 
import time
from Led import Led
from LegoTouchSensor import LegoTouchSensor
from HitechnicCompassSensor import HitechnicCompassSensor
from tool4robot import *

BP = brickpi3.BrickPi3()

# define the hardware.
ts = LegoTouchSensor(BP.PORT_2)
cs = HitechnicCompassSensor(BP.PORT_1)
led = Led()
time.sleep(10)

print ("Start")

try:
    led.blinkOn(1.5, 0.4)

    # wait until start.
    while True:
        time.sleep(0.1)
        if ts.isTouched():
            break
    time.sleep(2)
        
    led.blinkOff()
    waitBlink(led)
    led.blinkOn(1, 1)

    print ("start calibrate Compass Sensor")
    cs.startCalibration ()
    while not ts.isTouched():
        time.sleep(0.1)
    cs.endCalibration ()
    print ("end calibrate Compass Sensor")

except KeyboardInterrupt:
    pass
finally:
    led.blinkOff()
    BP.reset_all()
    
print ("Ende")
