#!/usr/bin/python
########################################
# class led                            #
# file: Led.py                         #
# Author: Th. Kaffka, Cologne, Germany #
# Date: 02.11.2020                     #
########################################

import brickpi3
import time
from threading import Thread

BP = brickpi3.BrickPi3()
ok = False
is_binking = False

class Led:

   def __init__(self):
      pass

   def __del__(self):
      BP.set_led(0) 
      
   def isBlinking(self):
       return is_binking
      
   def ledOn(self):
      BP.set_led(100) 

   def ledOff(self):
      BP.set_led(0) 

   def blinkOn(self, time1, time2):
      self.t = Thread(target=self.doBlink, args=(time1,time2,))
      self.t.setDaemon(True)
      self.t.start()
      
   def blinkOff(self):
      global ok
      ok = False

   def doBlink(self, time1, time2):
      global ok, is_binking
      ok = True
      is_binking = True
      while ok:
         self.ledOn()
         time.sleep(time1)
         self.ledOff()
         time.sleep(time1)
         self.ledOn()
         time.sleep(time2)
         self.ledOff()
         time.sleep(time2)
      is_binking = False
         