#!/usr/bin/python
########################################
# class lego color sensor              #
# file: LegoColorSensor.py             #
# Author: Th. Kaffka, Cologne, Germany #
# Date: 27.11.2020                     #
########################################

import brickpi3 

BP = brickpi3.BrickPi3()

sensor_color = ["none", "Black", "Blue", "Green", "Yellow", "Red", "White", "Brown"]

class LegoColorSensor:

   def __init__(self, port):
      self.port = port
      BP.set_sensor_type(port, BP.SENSOR_TYPE.EV3_COLOR_COLOR)

   def __del__(self):
      pass
      
   def getPort(self):
      return self.port

   def getColor(self):
      return BP.get_sensor(self.port)

   def getColorName(self):
      return sensor_color[BP.get_sensor(self.port)]
