#!/usr/bin/python
########################################
# program: avoid walls and objects     #
# file: AvoidWallsAndObjects.py        #
# Author: Th. Kaffka, Cologne, Germany #
# Date: 16.10.2020                     #
########################################
import sys
sys.path.append("/home/pi/Ae/Roboter/Interface")
import brickpi3 
import time
from random import *
from LegoMotor import LegoMotor
from LegoVehicle import *
from LegoInfraRedSensor import *
from Led import Led

BP = brickpi3.BrickPi3()

# define the hardware.
motor_l = LegoMotor(BP.PORT_B)
motor_r = LegoMotor(BP.PORT_C)
ir = LegoInfraRedSensor(BP.PORT_1)
vehicle = LegoVehicle(WHEEL_SIZE_EV3, 12.0, motor_l, motor_r)
led = Led()
time.sleep(10)

# global valibales.
power = 20
distance = 15
break_dist = 5

print ("Start")

try:
    led.blinkOn(1, 1)

    # wait until start.
    while True:
        time.sleep(0.1)
        value = ir.getDistance()
        if value < break_dist:
            break
        
    time.sleep(2)

    # prepare the vehicle.
    vehicle.setSpeed(power)
    vehicle.resetTachoCount()
    vehicle.backward()

    # avoid walls and objects.
    while True:
        time.sleep(0.1)
        value = ir.getDistance()
        
        if value < break_dist: # stop driving.
            break

        if value < distance: # avoid.
            vehicle.stop()
            time.sleep(2)
            led.blinkOff()
            led.blinkOn(1, 0.1)
            backdist = randint(10, 30)
            vehicle.forward(backdist)
            while vehicle.isMoving():
                pass
            time.sleep(2)
            angle = randint(30, 180)
            dir = randint(0, 1)
            if dir == 1:
                angle = angle * -1
            vehicle.rotate(angle)
            while vehicle.isMoving():
                pass
            time.sleep(2)
            vehicle.backward()
            led.blinkOff()
            led.blinkOn(1, 1)
        
except KeyboardInterrupt:
    pass
finally:
    vehicle.stop()
    led.blinkOff()
    BP.reset_all()
    
print ("Ende")
