#!/usr/bin/python
##########################################
# program: stay on the table             #
# file: StayOnTable.py                   #
# Author: Th. Kaffka, Cologne, Germany   #
# Date: 19.11.2020                       #
##########################################
import sys
sys.path.append("/home/pi/Ae/Roboter/Interface")
sys.path.append("/home/pi/Ae/Roboter/lib")
import brickpi3 
import time
from random import *
from LegoMotor import LegoMotor
from LegoVehicle import *
from LegoTouchSensor import LegoTouchSensor
from HitechnicGyroSensor import HitechnicGyroSensor
from LegoInfraRedSensor import LegoInfraRedSensor
import tool4robot as t4r

BP = brickpi3.BrickPi3()

# define the hardware.
motor_l = LegoMotor(BP.PORT_C)
motor_r = LegoMotor(BP.PORT_B)
ts = LegoTouchSensor(BP.PORT_3)
ir = LegoInfraRedSensor(BP.PORT_4)
gs = HitechnicGyroSensor(BP.PORT_1)
vehicle = LegoVehicle(WHEEL_SIZE_EV3, 11.0, motor_l, motor_r)
time.sleep(10)

#define constants.
SPEED = 20
POS_CORR = 85
DISTANCE = 20

# define global vars.
def_pos = 0

def avoid():
    vehicle.stop()
    time.sleep(2)
    backdist = randint(10, 20)
    vehicle.backward(backdist)
    while (vehicle.isMoving()):
        pass
    time.sleep(2)
    angle = randint(30, 100)
    dir = randint(0, 1)
    if dir == 1:
        angle = angle * -1
    vehicle.rotate(angle)
    while vehicle.isMoving():
        pass
    time.sleep(2)
    vehicle.forward()

print ("Start")

try:
    t4r.waitUntilTouch(ts)
    time.sleep(2)

    # prepare the vehicle.
    def_pos = gs.getPosition()
    vehicle.resetTachoCount()
    vehicle.setSpeed(SPEED)
    vehicle.forward()

    while True:
        dist = ir.getDistance()
        touch = ts.isTouched()
        pos = gs.getPosition()
        if (dist > DISTANCE):
            print("distance: ", dist)
            avoid()
        elif (touch):
            print("touch: ", touch)
            avoid()
        elif (pos > def_pos + POS_CORR):
            print("position: ", pos, def_pos, def_pos + POS_CORR)
            avoid()
           
except KeyboardInterrupt:
    pass
finally:
    vehicle.stop()
    BP.reset_all()
    
print ("Ende")
