#!/usr/bin/python
##########################################
# program: classifying training          #
# file: ClassifyingTraining.py           #
# Author: Th. Kaffka, Cologne, Germany   #
# Date: 13.01.2021                       #
##########################################
import sys
sys.path.append("/home/pi/Ae/Roboter/Interface")

from NeuralNetwork import NeuralNetwork

examples = []
examples_no = 0
factor = 0.0

#####################
# reads the examples.
def readExamples():
    f = open ("../data/DataClassifying.dat", "r")
    data = f.read()
    f.close()
    global examples, examples_no, factor
    exp_line = []
    number = ""
    exp_max = -1
    for c in data:
        if (c == "(" or c == ";"):
            continue
        elif (c == "\n"):
            number = ""
            examples.append(exp_line)
            exp_line = []
            examples_no += 1
            continue
        elif (c == "," or c == ")"):
            exp_max = max(exp_max, int(number))
            exp_line.append(int(number))
            number = ""
            continue
        number = number + c
    factor = 1.0 / (exp_max + 1.0)

################################
# saves the neural network data.
def saveData(nn):
    try:
        f = open ("../data/clsource.txt", "w")
        f.write("factor_x = " + str(factor) + "\r\n")
        f.write("factor_y = 0.9\r\n")
        for i in range(0, nn.nh + 1):
            for j in range(0, nn.x_columns + 1):
                f.write("w1[" + str(j) + "][" + str(i) + "] = " \
                       + str(nn.w1[j][i]) + "\r\n")
        for i in range(0, nn.y_columns):
            for j in range(0, nn.nh + 1):
                f.write("w2[" + str(j) + "][" + str(i) + "] = " \
                       + str(nn.w2[j][i]) + "\r\n")
    finally:
        f.close()

print ("Start")

try:

    readExamples()
    print ("examples: " + str(examples_no))
    
    nn = NeuralNetwork(12, 3, 0.3, 15, examples, examples_no, factor, 0.9)
    
    for ndx in range(100000):
        nn.learn()
        if (ndx % 100 == 0):
            print (".", end="")
        if (ndx % 1000 == 0):
            print (" " + str(ndx) + " " + str(nn.av_error))

    saveData(nn)

except KeyboardInterrupt:
    pass
finally:
    pass
    
print ("End")

