#!/usr/bin/python
########################################
# turret shooter                       #
# file: TurretShooter.py               #
# Author: Th. Kaffka, Cologne, Germany #
# Date: 26.01.2021                     #
########################################
import sys
sys.path.append("/home/pi/Ae/Roboter/Interface")
sys.path.append("/home/pi/Ae/Roboter/lib")
import brickpi3 
import time
import tool4robot as t4r

# import classes here.
from PatternRecogn import PatternRecogn
from LegoMotor import LegoMotor
from LegoTouchSensor import LegoTouchSensor

BP = brickpi3.BrickPi3()

# global valibales.
PIC_WIDTH = 60
PIC_HEIGHT = 44
GUN_POWER = 40
TURRET_POWER_FW = 8
TURRET_POWER_BK = 12

# define the hardware.
p_recog = PatternRecogn(PIC_WIDTH, PIC_HEIGHT)
motor_gun = LegoMotor(BP.PORT_C)
motor_turret = LegoMotor(BP.PORT_B)
park = LegoTouchSensor(BP.PORT_2)
time.sleep(10)

#####################
# shoot with the gun.
def shoot():
   motor_gun.resetTachoCount()
   motor_gun.forward(360)
   while(motor_gun.isMoving()):
      pass
      
#######################################
# move the turret to the park position.
def gotoPark():
   motor_turret.setSpeed(TURRET_POWER_BK)
   motor_turret.backward()
   while(not park.isTouched()):
      pass
   motor_turret.stop()
   motor_turret.resetTachoCount()
   time.sleep(3.0)

print ("Start")

try:

   # start a shooting session.
   t4r.waitUntilTouch(park)
   time.sleep(2)

   mid_pic = PIC_WIDTH / 2
   motor_gun.setSpeed(GUN_POWER)

   while (True):

      if (park.isTouched()):
         break

      gotoPark()

      # start search session.      
      motor_turret.setSpeed(TURRET_POWER_FW)
      motor_turret.forward()
      time.sleep(0.5)
      while(motor_turret.getEncoderDegrees() < 240 and (not park.isTouched())):
         motor_turret.forward()
         rect = p_recog.getMaxRect()
         if (rect == (0, 0, 0, 0)):
            print("not recognized")
            time.sleep(0.1)
            continue
         motor_turret.stop()
         time.sleep(0.1)
         mid_rect = rect[0] + (rect[2] - rect[0]) / 2
         if (mid_pic - 6 < mid_rect and mid_pic + 6 > mid_rect):
            shoot()
            print("shoot")
            break
         print(mid_rect)
         time.sleep(0.1)

      motor_turret.stop()

except KeyboardInterrupt:
   pass
finally:
    motor_turret.stop()
    BP.reset_all()

print ("End")
