#!/usr/bin/python3
########################################
# Robot Functions                      #
# file: tool4robot.py                  #
# Author: Th. Kaffka, Cologne, Germany #
# Date: 12.11.2020                     #
########################################
import time

compass_straight = 0
compass_left = 0
compass_right = 0
compass_back = 0

#######################################
# wait for led blink end.
def waitBlink(led):
    while led.isBlinking():
        pass

#######################################
# wait until touch.
def waitUntilTouch(touch):
    while True:
        time.sleep(0.1)
        if touch.isTouched():
            break
        
##############################################
# initalize the main directions of the compass.
def initDirection(compass):
   global compass_straight, compass_left, compass_right, compass_back
   compass_straight = compass.getDirection()
   compass_left = corrDirection(compass_straight + 270)
   compass_right = corrDirection(compass_straight + 90)
   compass_back = corrDirection(compass_straight + 180)

###################################
# correcting the direction setting.
def corrDirection(direction):
   if (direction > 359):
      direction -= 360
   elif (direction < 0):
      direction += 360
   return direction

#######################
# sum color components.
def sumColor(color):
   return color[0] + color[1] + color[2]